/******************************************************************************
  Target Script for Atmel AT91SAM7.

  Copyright (c) 2007 Rowley Associates Limited.

  This file may be distributed under the terms of the License Agreement
  provided with this software.

  THIS FILE IS PROVIDED AS IS WITH NO WARRANTY OF ANY KIND, INCLUDING THE
  WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 ******************************************************************************/

function Reset()
{
  /* Reset and stop target */
  TargetInterface.resetAndStop(1);

  CKGR_MOR_VAL = 0x00004001;
  CKGR_PLLR_VAL = 0x10483F0E; /* Set up the PLL (MCK, UDPCK = 18.432MHz * 73 / 14 / 2 = 48.05486MHz) */
  CKGR_MCKR_VAL1 = 0x00000004;
  CKGR_MCKR_VAL2 = 0x00000007;

  if (TargetInterface.setMaximumJTAGFrequency)
    {
      /* Configure Clock (post 1.6 version) */
      TargetInterface.setMaximumJTAGFrequency(32768);
      TargetInterface.pokeWord(0xFFFFFC20, CKGR_MOR_VAL);
      TargetInterface.pokeWord(0xFFFFFC2C, CKGR_PLLR_VAL);
      TargetInterface.pokeWord(0xFFFFFC30, CKGR_MCKR_VAL1);
      TargetInterface.pokeWord(0xFFFFFC30, CKGR_MCKR_VAL2);
      TargetInterface.setMaximumJTAGFrequency(10000000);
    }
  else
    {
      /* Configure Clock (1.6 version) */
      TargetInterface.pokeWord(0xFFFFFC20, CKGR_MOR_VAL);
      TargetInterface.delay(10);
      TargetInterface.pokeWord(0xFFFFFC2C, CKGR_PLLR_VAL);
      TargetInterface.delay(10);
      TargetInterface.pokeWord(0xFFFFFC30, CKGR_MCKR_VAL1);
      TargetInterface.delay(10);
      TargetInterface.pokeWord(0xFFFFFC30, CKGR_MCKR_VAL2);
      TargetInterface.delay(10);
    }
  /* Setup internal FLASH wait states */
  TargetInterface.pokeWord(0xFFFFFF60, 0x00000100);
  if (((TargetInterface.peekWord(0xFFFFF240) >> 8) & 0xF) >= 0xA)
    TargetInterface.pokeWord(0xFFFFFF70, 0x00000100);
}

function RAMReset()
{
  Reset();
  /* Remap SRAM to 0x00000000 */
  resetVector = TargetInterface.peekWord(0x00000000);
  ramResetVector = TargetInterface.peekWord(0x00200000);
  remap = resetVector != ramResetVector;
  if (!remap)
    {
      TargetInterface.pokeWord(0x00200000, resetVector ^ 0xFFFFFFFF);
      if (TargetInterface.peekWord(0x00000000) == resetVector)
        remap = 1;
      TargetInterface.pokeWord(0x00200000, ramResetVector);
    }
  if (remap)
    TargetInterface.pokeWord(0xFFFFFF00, 1); // MC_RCR 
}

function FLASHReset()
{
  Reset();
}

